QGIS Application - Bug report #21895
Default values and expression calculator not working together
2019-04-21 01:32 PM - Jonathan Moules

Status: Open

Priority: Normal

Assignee:

Category: Vectors

Affected QGIS version:3.4.3 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 29710
Description

While trying to work around #21892 | encountered the following.

To replicate (in a GeoPackage - probably not format specific):

1) Create a new field of type Integer called whatever (_MY_FIELD here)

2) Use the Layer Properties -> Attributes Form to set a default value of 0 on _MY_FIELD, and tick the "Apply default on update" (this is
the bug!)

3) Now, use expression calculator to UPDATE _MY_FIELD with any numerical value (fid will do).

Result = _MY_FIELD only has values of "0".

If you uncheck the "Apply default on update" then the update of the field will work as expected.

History

#1 - 2019-04-23 08:47 AM - Jiirgen Fischer
- Description updated

#2 - 2019-04-23 09:01 AM - Giovanni Manghi
- Category changed from Field calculator to Vectors

#3 - 2019-04-23 09:02 AM - Giovanni Manghi

On the other hand the default does not do completely his job in other situations, like #21868

#4 - 2019-04-23 09:13 AM - Jonathan Moules

| ended up having to work around it with a logical if statement:

if("NEW_VALUE" is null, "NEW_VALUE", 0)

But only a workaround.
